我已成功创建自己的服务脚本,但启动时遇到了一些问题。我从服务中调用以下脚本/usr/bin/myscript.sh
:
#!/bin/bash
tail -f /path/to/error.log|while read LINE;do
if grep -q "Fatal" <(echo $LINE); then
(
echo "From: [email protected]"
echo "To: [email protected]"
echo "Subject: PHP Error (URGENT!)"
echo $LINE
) | sendmail -t
fi
done
脚本本身没问题,因为当我手动运行它时它可以工作。但是,当启动调用该脚本的服务时,它实际上并没有在后台启动和运行。我认为这与正在进行的 while 循环有关,但我只是 shell 脚本的初学者。
我有以下内容/etc/init.d/myscript
#! /bin/sh
### BEGIN INIT INFO
# Provides: myscript
# Required-Start: $remote_fs $syslog
# Required-Stop: $remote_fs $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: myscript shortdesc
# Description: myscript longdesc
### END INIT INFO
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="myscript desc"
NAME=myscript
DAEMON=/usr/bin/$NAME.sh
DAEMON_ARGS="--options args"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
[ -x "$DAEMON" ] || exit 0
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
. /lib/init/vars.sh
. /lib/lsb/init-functions
do_start()
{
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
$DAEMON_ARGS \
|| return 2
}
do_stop()
{
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
rm -f $PIDFILE
return "$RETVAL"
}
case "$1" in
start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
status)
status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
;;
restart)
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;;
*) log_end_msg 1 ;;
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
echo "Usage: $SCRIPTNAME {start|stop|status|restart}" >&2
exit 3
;;
esac
:
update-rc.d
当我启动服务时,我也运行了它( service myscript start
),它给出的输出与我运行脚本本身时的输出相同,它只是空白(因为脚本没有输出任何内容)。我猜它确实调用了脚本,但没有在后台运行它。
这两个文件也都经过了 chmod 处理。
exec > /tmp/log 2>&1
我已按照评论中的要求在脚本开头添加了内容以进行调试,但文件却是空的。
我们正在使用 Ubuntu 14.04 LTS。
答案1
所以我解决了这个问题,我所要做的就是&
在完成之后添加一个。这样就解决了所有问题。感谢大家的帮助。
#!/bin/bash
tail -f /path/to/error.log|while read LINE;do
if grep -q "Fatal" <(echo $LINE); then
(
echo "From: [email protected]"
echo "To: [email protected]"
echo "Subject: PHP Error (URGENT!)"
echo $LINE
) | sendmail -t
fi
done &